"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ReportEventCancer(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "actions",
        "genomicFeatureCancer",
        "reportEventId",
        "soNames",
        "soTerms",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "actions": reports_3_0_0.Actions,
            "genomicFeatureCancer": reports_3_0_0.GenomicFeatureCancer,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "tier": reports_3_0_0.Tier,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "org.gel.models.report.avro.Actions": reports_3_0_0.Actions,
            "org.gel.models.report.avro.GenomicFeatureCancer": reports_3_0_0.GenomicFeatureCancer,
            "org.gel.models.report.avro.Tier": reports_3_0_0.Tier,
            "org.gel.models.report.avro.ReportEventCancer": reports_3_0_0.ReportEventCancer,
        }

    __slots__ = [
        "actions",
        "genomicFeatureCancer",
        "reportEventId",
        "soNames",
        "soTerms",
        "tier",
    ]

    def __init__(
        self,
        actions,
        genomicFeatureCancer,
        reportEventId,
        soNames,
        soTerms,
        tier=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_3_0_0.ReportEventCancer model.

        :param actions:
        :type actions: list[Actions]
        :param genomicFeatureCancer:
            This is the genomicsFeature of interest for this reported variant,
            please note that one variant can overlap more that one
            gene/transcript     If more than one gene/transcript is
            considered interesting for this particular variant, should
            be reported in two different ReportEvents
        :type genomicFeatureCancer: GenomicFeatureCancer
        :param reportEventId:
            Unique identifier for each report event, this has to be unique across
            the whole report, and it will be used by GEL     to
            validate the report
        :type reportEventId: str
        :param soNames:
            SO name used in tier
        :type soNames: list[str]
        :param soTerms:
            SO Term used in tier
        :type soTerms: list[str]
        :param tier:
            Gel Tier
        :type tier: None | Tier
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.0.0"
